/*
 *  Memory sub-system initialization code for TANBAC Evaluation board TB0229.
 *
 *  Copyright (c) 2003  Masami Komiya <mkomiya@sonare.it>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2, or (at
 * your option) any later version.
 */

#include <config.h>
#include <version.h>
#include <asm/regdef.h>
#include <asm/mipsregs.h>


	.globl  lowlevel_init
lowlevel_init:
	mfc0		t0, CP0_STATUS		# clear RE bit
	li		t1, 0xfdffffff
	and		t0, t0,t1
	mtc0		t0, CP0_STATUS


/*********************************************************************
* exbus
*********************************************************************/
/* 	PCS0 */
/* 	BASE ADDRESS = 1F800000 */
/* 	SIZE = 8M Byte */
	la 		t0, 0xAF021000
	li 		t1, 0x1F80000C
	sw 		t1, 0x00(t0)
/* 	PCS0TIM */
/* 	FLASH ACSESS TIME = 100nS */
	li 		t1, 0x00901CE1
	sw 		t1, 0x20(t0)

/*********************************************************************
* clock mask unit CMU
*********************************************************************/
/* 	CMU CLKMASK */
/* 	ALL CLOCK ENABLE */
	la 		t0, 0xAF000060
	li 		t1, 0x0732
	sh 		t1, 0x00(t0)
/* 	CMU CLKMASK2 */
/* 	ALL CLOCK ENABLE */
	la 		t0, 0xAF000064
	li 		t1, 0x013f
	sh 		t1, 0x00(t0)

/*********************************************************************
* system control unit SCU
*********************************************************************/
	la 		t0, 0xAF008000
/* scupinmux1reg */
	li 		t1,0x00000000	
	sw 		t1, 0x00(t0)
/* scupinmux2reg */
	li 		t1,0xFFF03FFC	
	sw 		t1, 0x04(t0)
/* scupinmux3reg */
	li 		t1,0x0F000540	
	sw 		t1, 0x08(t0)
/* scupinmux4reg */
	li 		t1,0x000F000F	
	sw 		t1, 0x0C(t0)
/* scupinmux5reg */
	li 		t1,0x00005555	
	sw 		t1, 0x10(t0)
/* scupinfloatreg */
	li 		t1,0x00000000	
	sw 		t1, 0x80(t0)
/*********************************************************************
* init serial port
*********************************************************************/
	/* SIU init */
	la	t0,0xaf006800	/*siu reset register */
	
	/* reset register */
	li	t3,0x1
	sb	t3,0x09(t0)		/* siu reset */
	nop
	nop
	nop
	nop
	nop
	nop
	sb	$0,0x09(t0)			/* siu reset release */

/*********************************************************************
/* AHB arbitor   Fixed priority
*********************************************************************/
	la	t0,0xaf0082c0
	li	t1,0x10000000
	sw	t1,0x00(t0)
	lw	t1,0x00(t0)

/*********************************************************************
* WTOP DDRM CONTROLLER
*********************************************************************/
	la 		t0, 0xAF00D000
/* mif soft reset */
	li 		t1,0x00000007	/* reset */
	sw 		t1, 0x00(t0)

	li		t2,0x00010000
	li		t3,0x00000000
dummy_loop_1:
	nop
	addi	t3,t3,0x01
	bne		t2,t3,dummy_loop_1
	nop

	li 		t1,0x00000000	/* reset release */
	sw 		t1, 0x00(t0)

/* mif cfg1 */
	li 		t1,0x68239863		/* cl3 */
	li 		t1,0x58239863		/* cl2.5 */
	li 		t1,0x50318963		/* cl2.5 */
	li 		t1,0x40318963		/* cl2 */
	li 		t1,0x48239863		/* cl2 */

	sw 		t1, 0x1c(t0)
/* mif cfg2 */
	li 		t1,0x00000500
	li 		t1,0x00000ff0
	li 		t1,0x000005f0
	sw 		t1, 0x20(t0)
/* mif cfg3 */
	li 		t1,0x00001000
	li 		t1,0x00000f00
	sw 		t1, 0x24(t0)

	li		t2,0x00010000
	li		t3,0x00000000
dummy_loop_2:
	nop
	addi	t3,t3,0x01
	bne		t2,t3,dummy_loop_2
	nop

/* mif init */
	li 		t1,0x00000020
	sw 		t1, 0x04(t0)
	nop
	nop
	li 		t1,0x10000004
	sw 		t1, 0x04(t0)
	nop
	nop
	li 		t1,0x00010002
	sw 		t1, 0x04(t0)
	nop
	nop
	li 		t1,0x04c80002	/* cl = 3    burst = 4 */
	li 		t1,0x05880002	/* cl = 2.5  burst = 4 */
	li 		t1,0x04880002	/* cl = 2    burst = 4 */

	sw 		t1, 0x04(t0)
	nop
	nop
	li 		t1,0x10000004
	sw 		t1, 0x04(t0)
	nop
	nop
	li 		t1,0x00000001
	sw 		t1, 0x04(t0)
	nop
	nop
	li 		t1,0x00000001
	sw 		t1, 0x04(t0)
	nop
	nop
	li 		t1,0x00c80002	/* cl = 3  burst = 4 */
	li 		t1,0x01880002	/* cl = 2.5  burst = 4 */
	li 		t1,0x00880002	/* cl = 2  burst = 4 */
	sw 		t1, 0x04(t0)
	nop

	li		t2,0x00001000
	li		t3,0x00000000
dummy_loop_3:
	nop
	addi	t3,t3,0x01
	bne		t2,t3,dummy_loop_3
	nop

	li 		t1,0x00000140	/* mif ref count */
	sw 		t1, 0x18(t0)


/*********************************************************************
* led control unit LED
*********************************************************************/
	la 		t0, 0xAF004180
/* led hts reg   */
	li 		t1,0x0008	
	sh 		t1, 0x00(t0)
/* led lts reg   */
	li 		t1,0x0008	
	sh 		t1, 0x02(t0)
/* led cont reg */
	li 		t1,0x0001	
	sw 		t1, 0x08(t0)

	j       ra
	nop
	nop
