/*
 * (C) Copyright 2007 Media Lab.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef __CONFIG_H
#define __CONFIG_H

#define CONFIG_MIPS32		1	/* MIPS 4Kc CPU core	*/
#define CONFIG_TB0322		1	/* on a TB0322 Board	*/
#define CONFIG_VR4155		1	/* VR4155 */

#define CPU_CLOCK		336000000	/* 336 MHz */

#define CONFIG_CONS_INDEX	1
#define CONFIG_BOOTDELAY	5	/* autoboot after 5 seconds	*/

#define CONFIG_BAUDRATE		115200

#define CFG_BAUDRATE_TABLE	{ 9600, 19200, 38400, 57600, 115200 }

#define CONFIG_TIMESTAMP		/* Print image info with timestamp */

#define CONFIG_JFFS2_CMDLINE
#define MTDIDS_DEFAULT		"nor0=tb0322"
#define MTDPARTS_DEFAULT	"mtdparts=tb0322:4M(root),256k(u-boot),"	\
				"64k(ubootenv),-(opt)"

#undef	CONFIG_BOOTARGS

#define CFG_HUSH_PARSER

#ifdef CFG_HUSH_PARSER
#define CONFIG_PREBOOT	"echo \'\n"					\
	"Type \"boot\"		for default way\n"			\
	"Type \"run cram\"		to boot from flash\n"		\
	"Type \"run nfs\"		to boot from NFS\n"		\
	"Type \"run usb\"		to boot from USB-disk\n"	\
	"Type \"run initrd\"	to boot with initrd\'"

#define CONFIG_AUTO_COMPLETE	1
#define CFG_PROMPT_HUSH_PS2  "> "
#define CONFIG_EXTRA_ENV_SETTINGS					\
	"bootargs=root=/dev/mtdblock0 ro console=ttyS0,$baudrate\0"	\
	"autoload=no\0"							\
	"netretry=once\0"						\
	"verify=no\0"							\
	"cram_start=BF800000\0"						\
	"cram_size=400000\0"						\
	"uboot_start=BFC00000\0"					\
	"uboot_size=40000\0"						\
	"env_start=BFC40000\0"						\
	"env_size=10000\0"						\
	"opt_start=BFC50000\0"						\
	"opt_size=3BFFFF\0"						\
	"bootfile=uImage\0"						\
	"ubootfile=u-boot.bin\0"					\
	"initrdfile=ramImage\0"						\
	"cramfile=rom.img\0"						\
	"cramargs=setenv bootargs root=/dev/mtdblock0 ro\0"		\
	"nfsargs=setenv bootargs root=/dev/nfs "			\
		"ip=$ipaddr:$serverip:$gatewayip:$netmask::eth0: "	\
		"nfsroot=$nfsroot ro\0"					\
	"usbargs=setenv bootargs $bootargs rootdev=$rootdev "		\
		"devorder=$devorder fstype=$fstype timeout=$timeout\0"	\
	"userargs=setenv bootargs $bootargs console=ttyS0,$baudrate mem=128M\0"	\
	"load_kernel_cram=fsload $bootfile\0"				\
	"load_kernel_tftp=run checkipaddr&&tftp 80400000 $bootfile\0"	\
	"load_kernel_nfs=run checknfsbase checkipaddr&&"		\
		"nfs 80400000 $nfsbase$bootfile\0"			\
	"load_method=nfs tftp cram\0"					\
	"load_kernel=method=none; for i in $load_method;" 		\
		"do test $method = none&&if run load_kernel_$i;then "	\
		"method=$i; fi; done; test $method != none &&"	\
		"iminfo 80400000\0"					\
	"load_initrd_cram=fsload $initrdfile\0"				\
	"load_initrd_tftp=run checkipaddr&&tftp 80500000 $initrdfile\0"	\
	"load_initrd_nfs=run checknfsbase checkipaddr&&"		\
		"nfs 80500000 $nfsbase$initrdfile\0"			\
	"load_initrd=method=none; for i in $load_method;" 		\
		"do test $method = none&&if run load_initrd_$i;then "	\
		"method=$i; fi; done; test $method != none &&"	\
		"iminfo 80500000\0"					\
	"load_cram_tftp=run checkipaddr&&tftp 80400000 $cramfile\0"	\
	"load_cram_nfs=run checknfsbase checkipaddr&&"			\
		"nfs 80400000 $nfsbase$cramfile\0"			\
	"update_method=nfs\0"						\
	"load_cram=run load_cram_$update_method\0"			\
	"load_uboot_tftp=run checkipaddr&&tftp 80400000 $ubootfile\0"	\
	"load_uboot_nfs=run checknfsbase checkipaddr&&"			\
		"nfs 80400000 $nfsbase$ubootfile\0"			\
	"load_uboot=run load_uboot_$update_method\0"			\
	"cram=if run load_kernel_cram; then run cramargs userargs;"	\
		"bootm;fi\0"						\
	"nfs=if run load_kernel_nfs;then run nfsargs userargs &&"	\
		"bootm;fi\0"						\
	"usb=if run load_kernel_cram;then run cramargs usbargs userargs;"\
		"bootm;fi\0"						\
	"initrd=if run load_kernel load_initrd; then "			\
		"run nfsargs userargs;bootm 80400000 80500000;"		\
		"fi\0"							\
	"checknfsbase=if test x$nfsbase = x;then "			\
		"echo \"*** ERROR: \'nfsbase\' not set\";test a = b;"	\
		"else test 1 = 1;fi\0"					\
	"checkipaddr=if test x$ipaddr = x;then dhcp;"			\
		"else test 1 = 1;fi\0"					\
	"init_uboot=protect off $uboot_start +$uboot_size;"		\
		"echo erasing uboot area;"				\
		"erase $uboot_start +$uboot_size\0"			\
	"init_cram=protect off $cram_start +$cram_size;"		\
		"echo erasing cram area;"				\
		"erase $cram_start +$cram_size\0"			\
	"init_env=protect off $env_start +$env_size;"			\
		"echo erasing env area;"				\
		"erase $env_start +$env_size\0"				\
	"init_opt=protect off $opt_start +$opt_size;"			\
		"echo erasing opt area;"				\
		"erase $opt_start +$opt_size\0"				\
	"verify_uboot=if run load_uboot; then "				\
		"echo verifying image;"					\
		"cmp.b 80400000 $uboot_start $filesize;"		\
		"else test a = b;fi\0"					\
	"verify_cram=if run load_cram; then "				\
		"echo verifying image;"					\
		"cmp.b 80400000 $cram_start $filesize;"			\
		"else test a = b;fi\0"					\
	"update_uboot=if run load_uboot&&itest $filesize < $uboot_size;"\
 		"then run init_uboot;"					\
		"cp.b 80400000 $uboot_start $filesize;"			\
		"run verify_uboot && reset;"				\
		"fi\0"							\
	"update_cram=if run load_cram&&itest $filesize < $cram_size;"	\
		"then run init_cram;"					\
		"cp.b 80400000 $cram_start $filesize;"			\
		"run verify_cram;"					\
		"fi\0"							\
	"bootorder=cram usb nfs\0"					\
	"tryboot=for i in $bootorder; do run $i; done\0"		\
	"mtdids=" MTDIDS_DEFAULT	"\0"				\
	"mtdparts=" MTDPARTS_DEFAULT	"\0"				\
	""

#define CONFIG_BOOTCOMMAND	"run tryboot"
#else
#define CONFIG_PREBOOT	"echo;"						\
	"echo 'Type \"boot\"		for default way';"		\
	"echo 'Type \"run cram\"		to boot from flash';"	\
	"echo 'Type \"run nfs\"		to boot from NFS';"		\
	"echo 'Type \"run usb\"		to boot from USB-disk';"	\
	"echo 'Type \"run initrd\"	to boot with initrd';"		\
	"echo"

#define CONFIG_EXTRA_ENV_SETTINGS					\
	"bootargs=root=/dev/mtdblock0 ro console=ttyS0,$(baudrate)\0"	\
	"autoload=no\0"							\
	"netretry=once\0"						\
	"verify=no\0"							\
	"cram_start=BF800000\0"						\
	"cram_size=400000\0"						\
	"uboot_start=BFC00000\0"					\
	"uboot_size=40000\0"						\
	"env_start=BFC40000\0"						\
	"env_size=10000\0"						\
	"opt_start=BFC50000\0"						\
	"opt_size=3B0000\0"						\
	"bootfile=uImage\0"						\
	"ubootfile=u-boot.bin\0"					\
	"initrdfile=ramImage\0"						\
	"cramfile=rom.img\0"						\
	"cramargs=setenv bootargs root=/dev/mtdblock0 ro\0"		\
	"nfsargs=setenv bootargs root=/dev/nfs "			\
		"ip=$(ipaddr):$(serverip):$(gatewayip):$(netmask)::eth0: "	\
		"nfsroot=$(nfsroot) ro\0"				\
	"usbargs=setenv bootargs $(bootargs) rootdev=$(rootdev) "	\
		"devorder=$(devorder) fstype=$(fstype) timeout=$(timeout)\0"\
	"userargs=setenv bootargs $(bootargs) console=ttyS0,$(baudrate) mem=128M\0"\
	"nfsbase=192.168.3.91:/usr/src/mldbox/\0"			\
	"nfsroot=192.168.3.91:/usr/src/mldbox/rom\0"			\
	"load_kernel_cram=fsload $(bootfile)\0"				\
	"load_kernel_tftp=tftp 80400000 $(bootfile)\0"			\
	"load_kernel_nfs=nfs 80400000 $(nfsbase)$(bootfile)\0"		\
	"load_method=nfs\0"						\
	"load_kernel=run load_kernel_$(load_method); iminfo 80400000\0"	\
	"load_initrd_cram=fsload $(initrdfile)\0"			\
	"load_initrd_tftp=tftp 80500000 $(initrdfile)\0"		\
	"load_initrd_nfs=nfs 80500000 $(nfsbase)$(initrdfile)\0"	\
	"load_initrd=run load_initrd_$(load_method);iminfo 80500000\0"	\
	"load_cram_tftp=tftp 80400000 $(cramfile)\0"			\
	"load_cram_nfs=nfs 80400000 $(nfsbase)$(cramfile)\0"		\
	"update_method=nfs\0"						\
	"load_cram=run load_cram_$(update_method)\0"			\
	"load_uboot_tftp=tftp 80400000 $(ubootfile)\0"			\
	"load_uboot_nfs=nfs 80400000 $(nfsbase)$(ubootfile)\0"		\
	"load_uboot=run load_uboot_$(update_method)\0"			\
	"cram=run load_kernel_cram cramargs userargs; bootm\0"		\
	"nfs=run load_kernel_nfs nfsargs userargs;bootm\0"		\
	"usb=run load_kernel_cram cramargs usbargs userargs;bootm\0"	\
	"initrd=run load_kernel load_initrd nfsargs userargs;"		\
		"bootm 80400000 80500000\0"				\
	"init_cram=protect off $(cram_start) +$(cram_size);"		\
		"echo erasing cram area;"				\
		"erase $(cram_start) +$(cram_size)\0"			\
	"init_uboot=protect off $(uboot_start) +$(uboot_size);"		\
		"echo erasing uboot area;"				\
		"erase $(uboot_start) +$(uboot_size)\0"			\
	"init_opt=protect off $(opt_start) +$(opt_size);"		\
		"echo erasing opt area;"				\
		"erase $(opt_start) +$(opt_size)\0"			\
	"init_env=protect off $(env_start) +$(env_size);"		\
		"echo erasing env area;"				\
		"erase $(env_start) +$(env_size)\0"			\
	"verify_cram=run load_cram;"					\
		"echo verifying;"					\
		"cmp.b 80400000 $(cram_start) $(filesize)\0"		\
	"verify_uboot=run load_uboot;echo verifying;"			\
		"cmp.b 80400000 $(uboot_start) $(filesize)\0"		\
	"update_cram=run load_cram init_cram;"				\
		"cp.b 80400000 $(cram_start) $(filesize);"		\
		"run verify_cram\0"					\
	"update_uboot=run load_uboot init_uboot;"			\
		"cp.b 80400000 $(uboot_start) $(filesize);"		\
		"run verify_uboot\0"					\
	""
#define CONFIG_BOOTCOMMAND	"fsload uImage; bootm"
#endif

#define CONFIG_COMMANDS		(CONFIG_CMD_DFL | \
				 CFG_CMD_ASKENV | \
				 CFG_CMD_EEPROM | \
				 CFG_CMD_SPI	| \
/*				 CFG_CMD_I2C	|*/ \
				 CFG_CMD_DATE	| \
				 CFG_CMD_JFFS2	| \
				 CFG_CMD_SNTP	| \
				 CFG_CMD_DHCP	| \
				 CFG_CMD_PING	| \
				 CFG_CMD_MII	| \
				 CFG_CMD_PCI	| \
				 CFG_CMD_ELF	)
#define CONFIG_BOOTP_MASK	CONFIG_BOOTP_ALL
#include <cmd_confdefs.h>

/*
 * Miscellaneous configurable options
 */
#define CFG_LONGHELP				/* undef to save memory	     */
#define CFG_PROMPT		"# "		/* Monitor Command Prompt    */
#define CFG_CBSIZE		512		/* Console I/O Buffer Size   */
#define CFG_PBSIZE (CFG_CBSIZE+sizeof(CFG_PROMPT)+16)  /* Print Buffer Size */
#define CFG_MAXARGS		16		/* max number of command args*/

#define CFG_MALLOC_LEN		128*1024

#define CFG_BOOTPARAMS_LEN	128*1024

#define CFG_HZ			(CPU_CLOCK/8)

#define CFG_SDRAM_BASE		0x80000000

#define CFG_LOAD_ADDR		0x80400000	/* default load address */

#define CFG_MEMTEST_START	0x80000000
#define CFG_MEMTEST_END		0x87F4FFFF
#define CFG_ALT_MEMTEST		1
#define CFG_MEMTEST_SCRATCH	0xA7F50004
/*-----------------------------------------------------------------------
 * FLASH and environment organization
 */
#define CFG_FLASH_CFI
#define CFG_FLASH_CFI_DRIVER
#define CFG_MAX_FLASH_BANKS		(1)
#define CFG_MAX_FLASH_SECT		(256)
#define CFG_FLASH_CFI_WIDTH		FLASH_CFI_16BIT
#define CFG_FLASH_USE_BUFFER_WRITE	1

#define PHYS_FLASH_1		0xbf800000 /* Flash Bank #1 */

#define CFG_JFFS_CUSTOM_PART	1
#define __SIZE_TYPE__		unsigned int
/* The following #defines are needed to get flash environment right */
#define CFG_MONITOR_BASE	TEXT_BASE
#define CFG_MONITOR_LEN		(256 << 10)

#define CFG_INIT_SP_OFFSET	0x400000

#define CFG_FLASH_BASE		PHYS_FLASH_1

/* timeout values are in ticks */
#define CFG_FLASH_ERASE_TOUT	(5 * CFG_HZ) /* Timeout for Flash Erase */
#define CFG_FLASH_WRITE_TOUT	(2 * CFG_HZ) /* Timeout for Flash Write */

#define CFG_ENV_IS_IN_FLASH	1

/* Address and size of Primary Environment Sector	*/
#define CFG_ENV_ADDR		0xBFC40000
#define CFG_ENV_SIZE		0x10000

#define CFG_DIRECT_FLASH_TFTP

#define CONFIG_NR_DRAM_BANKS	1

/*-----------------------------------------------------------------------
 * Cache Configuration
 */
#define CFG_DCACHE_SIZE		32768
#define CFG_ICACHE_SIZE		32768
#define CFG_CACHELINE_SIZE	32
#define CACHE_LOCK_SIZE		(CFG_DCACHE_SIZE/4)
#define MIPS_MAX_CACHE_SIZE	0x8000
/*-----------------------------------------------------------------------
 * Serial Configuration
 */
#define CFG_NS16550
#define CFG_NS16550_SERIAL
#define CFG_NS16550_REG_SIZE	 1
#define CFG_NS16550_CLK		 18432000
#define CFG_NS16550_COM1	 0xaf006800

/*-----------------------------------------------------------------------
 * NETWORK stuff
 */
#define CONFIG_NET_MULTI
#define CFG_RX_ETH_BUFFER	16
#if 1
#define CONFIG_VR4155_ETH	2
#else
#define CONFIG_VR4155_ETH	1
#endif
#define CONFIG_HAS_ETH1
#define CONFIG_MII		1

/*-----------------------------------------------------------------------
 * SPI stuff
 */
#define CONFIG_SPI			1
#if 1
#define CONFIG_VR4155_CSI		1
#else
#include <asm/vr4155.h>
#define CONFIG_SOFT_SPI			1
#define SPI_INIT			GIUIOSELH &= ~(1<<9); GIUIOSELH |= (1<<10)|(1<<8); SPI_SCL(0)
#define SPI_SCL(bit)			if (bit) GIUPIODH |= (1<<10); else GIUPIODH &= ~(1<<10)
#define SPI_SDA(bit)			if (bit) GIUPIODH |= (1<<8); else GIUPIODH &= ~(1<<8)
#define SPI_DELAY			udelay(5)
#define SPI_READ			(GIUPIODH & (1<<9))?1:0
#endif
#define CFG_SPI_EEPROM_DEVID		0
#define CFG_SPI_RTC_DEVID		1

#define CONFIG_RTC_RX5C348
/*-----------------------------------------------------------------------
 * I2C stuff
#define CONFIG_VR4155_I2C		1
 */
/*-----------------------------------------------------------------------
 * PCI stuff
 */
#if 0
#define CONFIG_PCI
#define CONFIG_PCI_PNP
#endif

#if 0
#define CONFIG_SKIP_LOW_LEVEL_INIT	1
#endif
#define CONFIG_MISC_INIT_R		1

#endif	/* __CONFIG_H */
